Next Previous Up Contents
Next: quantile
Up: Layer Types
Previous: fill

#### 8.3.30 `vecfield`

Plots a field of arrows on a regular grid corresponding to the aggregated (typically averaged) value of a 2-d vector quantity for the points in that grid cell.

Currently, the X and Y components of the vectors are normalised separately and sized by default so that the arrows are shown with components comparable to the dimensions of the grid cells. This length can be adjusted by use of the `scale` option.

By default, the absolute values of the vectors are plotted. However, if the `relative` option is set, the mean vector value averaged over the visible plot area will be calculated and subtracted from all the plotted vectors. The effect of this is to show local variations rather than absolute values of the vectors over the visible area.

The X and Y dimensions of the grid cells (or equivalently histogram bins) can be configured either in terms of the data coordinates or relative to the plot dimensions.

Usage Overview:

       layerN=vecfield colorN=<rrggbb>|red|blue|...
                       arrowN=small_arrow|medium_arrow|... thickN=<int-value>
                       scaleN=<number> relativeN=true|false combineN=mean|sum
                       xbinsizeN=+<extent>|-<count> ybinsizeN=+<extent>|-<count>
                       xphaseN=<number> yphaseN=<number> xN=<num-expr>
                       yN=<num-expr> vxN=<num-expr> vyN=<num-expr>
                       weightN=<num-expr> inN=<table> ifmtN=<in-format>
                       istreamN=true|false icmdN=<cmds>

All the parameters listed here affect only the relevant layer, identified by the suffix `N`.

Example:

       stilts plot2plane xpix=600 ypix=300
                         in=tgas_source.fits x=ra y=dec
                         layer_1=mark shading_1=density densemap_1=cividis densefunc_1=linear
                         layer_2=vecfield vx_2=pmra vy_2=pmdec color_2=blue arrow_2=medium_arrow thick_2=1

`arrowN = small_arrow|medium_arrow|...` (MultiPointShape)
  How arrows are represented.

  The available options are:

  - `small_arrow`
  - `medium_arrow`
  - `large_arrow`
  - `small_open_dart`
  - `medium_open_dart`
  - `large_open_dart`
  - `small_filled_dart`
  - `medium_filled_dart`
  - `large_filled_dart`
  - `lines`
  - `capped_lines`

  [Default: `small_arrow`]

`colorN = <rrggbb>|red|blue|...` (Color)
  The color of plotted data, given by name or as a hexadecimal RGB value.

  The standard plotting colour names are `red`, `blue`, `green`, `grey`, `magenta`, `cyan`, `orange`, `pink`, `yellow`, `black`, `light_grey`, `white`. However, many other common colour names (too many to list here) are also understood. The list currently contains those colour names understood by most web browsers, from `AliceBlue` to `YellowGreen`, listed e.g. in the Extended color keywords section of the CSS3 standard.

  Alternatively, a six-digit hexadecimal number RRGGBB may be supplied, optionally prefixed by "`#`" or "`0x`", giving red, green and blue intensities, e.g. "`ff00ff`", "`#ff00ff`" or "`0xff00ff`" for magenta.

  [Default: `red`]

`combineN = mean|sum` (Combiner)
  Defines how the vector quantities in each given grid cell will be combined together to produce the vector to be displayed in that cell.

  The available options are:

  - `mean`: the mean of the combined values
  - `sum`: the sum of all the combined values per bin

  [Default: `mean`]

`icmdN = <cmds>` (ProcessingStep[])
  Specifies processing to be performed on the layer N input table as specified by parameter `inN`. The value of this parameter is one or more of the filter commands described in Section 6.1. If more than one is given, they must be separated by semicolon characters (";"). This parameter can be repeated multiple times on the same command line to build up a list of processing steps. The sequence of commands given in this way defines the processing pipeline which is performed on the table.

  Commands may alternatively be supplied in an external file, by using the indirection character '`@`'. Thus a value of "`@filename`" causes the file `filename` to be read for a list of filter commands to execute. The commands in the file may be separated by newline characters and/or semicolons, and lines which are blank or which start with a '`#`' character are ignored. A backslash character '`\`' at the end of a line joins it with the following line.

`ifmtN = <in-format>` (String)
  Specifies the format of the input table as specified by parameter `inN`. The known formats are listed in Section 5.1.1. This flag can be used if you know what format your table is in. If it has the special value `(auto)` (the default), then an attempt will be made to detect the format of the table automatically. This cannot always be done correctly however, in which case the program will exit with an error explaining which formats were attempted. This parameter is ignored for scheme-specified tables.

  [Default: `(auto)`]

`inN = <table>` (StarTable)
  The location of the input table. This may take one of the following forms:
  - A filename.
  - A URL.
  - The special value "`-`", meaning standard input. In this case the input format must be given explicitly using the `ifmtN` parameter. Note that not all formats can be streamed in this way.
  - A scheme specification of the form `:<scheme-name>:<scheme-args>`.
  - A system command line with either a "`<`" character at the start, or a "`|`" character at the end ("`<syscmd`" or "`syscmd|`"). This executes the given pipeline and reads from its standard output. This will probably only work on unix-like systems.
  In any case, compressed data in one of the supported compression formats (gzip, Unix compress or bzip2) will be decompressed transparently.
`istreamN = true|false` (Boolean)
  If set true, the input table specified by the `inN` parameter will be read as a stream. It is necessary to give the `ifmtN` parameter in this case. Depending on the required operations and processing mode, this may cause the read to fail (sometimes it is necessary to read the table more than once). It is not normally necessary to set this flag; in most cases the data will be streamed automatically if that is the best thing to do. However it can sometimes result in less resource usage when processing large files in certain formats (such as VOTable). This parameter is ignored for scheme-specified tables.

  [Default: `false`]

`relativeN = true|false` (Boolean)
  If true, the mean vector value for the visible part of the field will be subtracted from all displayed vectors. This will display local variations in the vector field rather than its absolute value.

  [Default: `false`]

`scaleN = <number>` (Double)
  Scales the length of the arrows drawn. The default value, 1, attempts to draw them so that the longest arrows mostly fit inside the cells they represent, but adjusting this control will make all the arrows longer or shorter by the supplied factor.

  [Default: `1`]

`thickN = <int-value>` (Integer)
  Controls the line thickness when drawing vectors. Zero, the default value, means a 1-pixel-wide line is used, and larger values make drawn lines thicker. May not affect all vector shapes.

  [Default: `0`]

`vxN = <num-expr>` (String)
  X component of the vector field to be plotted.

  The value is a numeric algebraic expression based on column names as described in Section 10.

`vyN = <num-expr>` (String)
  Y component of the vector field to be plotted.

  The value is a numeric algebraic expression based on column names as described in Section 10.

`weightN = <num-expr>` (String)
  Weighting of data points. If supplied, each point contributes a value to the histogram equal to the data value multiplied by this coordinate. If not supplied, the effect is the same as supplying a fixed value of one.

  The value is a numeric algebraic expression based on column names as described in Section 10.

`xN = <num-expr>` (String)
  Horizontal coordinate.

  The value is a numeric algebraic expression based on column names as described in Section 10.

`xbinsizeN = +<extent>|-<count>` (BinSizer)
  Configures the extent of the vector grid bins on the X axis.

  If the supplied value is a positive number it is interpreted as a fixed size in data coordinates (if the X axis is logarithmic, the value is a fixed factor). If it is a negative number, then it will be interpreted as the approximate number of bins to display across the plot in the X direction (though an attempt is made to use only round numbers for bin sizes).

  When setting this value graphically, you can use either the slider to adjust the bin count or the numeric entry field to fix the bin size.

  [Default: `-16`]

`xphaseN = <number>` (Double)
  Controls where the zero point on the X axis is set. For instance if your bin size is 1, this value controls whether bin boundaries are at 0, 1, 2, .. or 0.5, 1.5, 2.5, ... etc.

  A value of 0 (or any integer) will result in a bin boundary at X=0 (linear X axis) or X=1 (logarithmic X axis). A fractional value will give a bin boundary at that value multiplied by the bin width.

  [Default: `0`]

`yN = <num-expr>` (String)
  Vertical coordinate.

  The value is a numeric algebraic expression based on column names as described in Section 10.

`ybinsizeN = +<extent>|-<count>` (BinSizer)
  Configures the extent of the vector grid bins on the Y axis.

  If the supplied value is a positive number it is interpreted as a fixed size in data coordinates (if the Y axis is logarithmic, the value is a fixed factor). If it is a negative number, then it will be interpreted as the approximate number of bins to display across the plot in the Y direction (though an attempt is made to use only round numbers for bin sizes).

  When setting this value graphically, you can use either the slider to adjust the bin count or the numeric entry field to fix the bin size.

  [Default: `-16`]

`yphaseN = <number>` (Double)
  Controls where the zero point on the Y axis is set. For instance if your bin size is 1, this value controls whether bin boundaries are at 0, 1, 2, .. or 0.5, 1.5, 2.5, ... etc.

  A value of 0 (or any integer) will result in a bin boundary at X=0 (linear X axis) or X=1 (logarithmic X axis). A fractional value will give a bin boundary at that value multiplied by the bin width.

  [Default: `0`]

Next Previous Up Contents
Next: quantile
Up: Layer Types
Previous: fill

STILTS - Starlink Tables Infrastructure Library Tool Set
Starlink User Note256
STILTS web page: http://www.starlink.ac.uk/stilts/
Author email: m.b.taylor@bristol.ac.uk
Mailing list: topcat-user@jiscmail.ac.uk